function f=mimo1sen(x,y,E,sign,w,ps,ms,qs,order,row,col,input_delay,pds,qds)
% Sensitivity function for the MIMO system
% Xwc_ub_w Xwc_lb_w are the upper and lower bound tables
% with a structure Xwc_ub_w{i,j}= matrix of many rows of [magnitude w x] 
% global Xwc_ub_w Xwc_lb_w
if iscell(E)
   e=E{1};
end
s=sqrt(-1)*w;
n=length(order);
for i=1:n
   filter(i)=1/(e(i)*s+1)^order(i);
end
filter=diag(filter);
q=inv(eval(qs))*filter;
m=eval(ms);
p=eval(ps);
pd=eval(pds);
if any(input_delay~=0)
    for i=1:n
        delay(i)=exp(-input_delay(i)*s);
    end
    delay=diag(delay);
    m=m*delay;
    p=p*delay;
end
temp=abs((eye(n)-m*q)*inv(eye(n)+(p-m)*q)*pd);
f=sign*temp(row,col);

