function [poly]=mt2poly(mt,x)
%[poly]=mt2poly(mt,x)
%convert matrix representing uncertain polynomial, for example (x(1)s+1) -> (1i + 1),
%to exact polynomial at certain value of x.
[r,c]=size(mt);
pnumx=[];
for i=1:r
 for j=1:c
  if imag(mt(i,j)) > 0
   pnumx(i,j)=x(imag(mt(i,j)));
  elseif imag(mt(i,j)) < 0
   pnumx(i,j)=-x(abs(imag(mt(i,j))));
  else
   pnumx(i,j)=mt(i,j);
  end
 end
end

poly=1;%pnumx(1,:);
for i=1:r
 poly=conv(poly,pnumx(i,:));
end
while poly(1)==0
 poly=poly(2:length(poly));
end
