function [k,n,d,string]=tcf(g)
%TCF TIME CONSTANT FORM
%    tcf(g) is used to display a transfer function, g, in time constant form.
%    [gain,num,den]= tcf(g) returns the gain, numerator polynomial matrix, num,
%    and denominator polynomial matrix, den, of the transfer function g and
%    displays the time constant form of g. It also prints the dead time associated 
%    with g, if any. The time constant form will also cancel common factors, if any.
%    Each row of num and den contains the coefficients of a polynomial in the 
%    numerator and denominator of g, respectively, with the common factors removed.
% Example:
% if 
%          5s + 15
%  g =  ----------------------
%     s^3 + 4s^2 + 9s + 10
%
% then tcf(g)
% returns:
%          1.5*(   0.33333 s + 1)
%  -------------------------------------------
%    (0.2 s^2 + 0.4 s + 1)*(   0.5 s + 1)
%
% and, [k,n,d]=tcf(g)
%
% returns:
%          1.5*(   0.33333 s + 1)
%  -------------------------------------------
%    (0.2 s^2 + 0.4 s + 1)*(   0.5 s + 1)
%   input delay: 0
%
%k = 1.5000
%
% n = 0    0.3333    1.0000
%
% d = 0.2000    0.4000    1.0000
%          0    0.5000    1.0000
 
n=nargout;
if n>=1 
   [k,n,d,string]=tcf1(g);
else 
   tcf2(g);
end
