function [Epsilon,xwc]=tune_solve1(Epsilon,fun,xwc,Mp,vub,vlb,y,ps,ms,qs,order,input_delay,pds,qds,E_handle)
global Xwc_ub_w % The variable that contain information of the upper bound.
tic
n=length(order);
ln=length(vub)+1;
option=optimset('LargeScale','off','Display','off');
switch fun
case 'mimo1com'
   constr='mimo1com_con';
   enorm_fun='enorm';
   enorm_con='enorm_constr';
case 'mimo2com'
   constr='mimo2com_con';
   enorm_fun='enorm2';
   enorm_con='enorm2_constr';
case 'mimopartial'
   constr='mimo2com_con';
   enorm_fun='epartial';
   enorm_con='epartial_constr';
end
for i=1:n % determine the worse case parameter from the existing upper bounde results
   if ~isempty(Xwc_ub_w{i,i}) & ~all(Xwc_ub_w{i,i}(:,3:end)==0)
      [temp,temp1]=max(Xwc_ub_w{i,i}(:,1));
      xwc(i,:)=[Xwc_ub_w{i,i}(temp1,3:end) ...
            Xwc_ub_w{i,i}(temp1,2)];
   else 
      xwc(i,:)=[xwc(i,2:end) xwc(i,1)];
   end
end
stop=0; 
while ~stop
for i=1:n
   vub(ln)=5*xwc(i,ln); % moving the frequency limits for the optimization
   vlb(ln)=0.2*xwc(i,ln);
   % do the optimixation to find the peak
   [xwc(i,:),fval(i)]=fmincon(fun,xwc(i,:),[],[],[],[],vlb,vub,constr,option,...
      y,Epsilon,-1,0,ps,ms,qs,order,i,i,input_delay,pds,qds);
   %  print_result(xwc(i,:))
   if fval(i)+Mp(i)< -0.001 % If the peak is higher than Mp, bring it down
      if strcmp(fun,'mimo1com')| strcmp(fun,'mimo2com')
         Epsilon{1}=fmincon(enorm_fun,Epsilon{1},[],[],[],[],Epsilon{1},[],enorm_con,option,...
            xwc,y,Mp',xwc(i,ln),ps,ms,qs,order,input_delay,pds,qds);
      elseif strcmp(fun,'mimopartial')
         Epsilon{2}=fmincon(enorm_fun,Epsilon{2},[],[],[],[],Epsilon{2},[],enorm_con,option,...
            xwc,y,Mp',xwc(i,ln),ps,ms,qs,order,input_delay,pds,qds);
      end
      disp(Epsilon{1})
   elseif fval(i)+Mp(i)> 0.001 % If the peak is lower than Mp, bring it up.
      if strcmp(fun,'mimo1com')| strcmp(fun,'mimo2com')
         Epsilon{1}=fmincon(enorm_fun,Epsilon{1},[],[],[],[],0.5*Epsilon{1},[],enorm_con,option,...
            xwc,y,Mp',xwc(i,ln),ps,ms,qs,order,input_delay,pds,qds);
      elseif strcmp(fun,'mimopartial')
         Epsilon{2}=fmincon(enorm_fun,Epsilon{2},[],[],[],[],0.5*Epsilon{2},[],enorm_con,option,...
            xwc,y,Mp',xwc(i,ln),ps,ms,qs,order,input_delay,pds,qds);
      end
      disp(Epsilon{1})
   end
end
if all(abs(fval+Mp)< 0.001)
   stop=1;
end
end
toc
% A sub function to print result

function print_result(X)
[m,n]=size(X);
for i=1:m
   fprintf('%g ',X(i,:));
   fprintf('\n');
end
