%View control system setting

NMENU=zeros(1,30);

if length(Epsilon{1,1})==1
   Epsilon{1,1}(2)=Epsilon{1,1}(1);
end

[f]=crfig(20,20,600,420,'System ','w','none','off');
uicontrol(f,...
  'Style','text',...
  'Position',[20 380 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Process(1): ');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 380 400 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',p{1,1,1}); % here
uicontrol(f,...
  'Style','text',...
  'Position',[20 360 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Process(2): ');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 360 400 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',p{1,1,2}); % here
uicontrol(f,...
  'Style','text',...
  'Position',[20 340 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Model(1): ');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 340 400 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',m{1,1,1}); % here
uicontrol(f,...
  'Style','text',...
  'Position',[20 320 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Model(2): ');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 320 400 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',m{1,1,2});
uicontrol(f,...
  'Style','text',...
  'Position',[20 300 200 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Forward path controller: ');
temp=strrep(q{1,1},'e',num2str(Epsilon{1,1}(1)));
uicontrol(f,...
  'Style','edit',...
  'Position',[175 300 400 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',temp);   
uicontrol(f,...
  'Style','text',...
  'Position',[20 280 150 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Process(1) lag, model:');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 280 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',pd{1,1});
uicontrol(f,...
  'Style','edit',...
  'Position',[380 280 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',mtx2str(Tcanc(2,:),1));
uicontrol(f,...
  'Style','text',...
  'Position',[20 260 150 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Feedback controller =');
temp=strrep(qf{1,1},'e',num2str(Epsilon{1,1}(2)));
uicontrol(f,...
  'Style','edit',...
  'Position',[175 260 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',temp); 
temp=strrep(qd{1,1},'e',num2str(Epsilon{1,1}(2)));
uicontrol(f,...
  'Style','edit',...
  'Position',[380 260 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',temp); 
uicontrol(f,...
  'Style','text',...
  'Position',[370 260 8 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','center',...
  'String','x'); 
uicontrol(f,...
  'Style','text',...
  'Position',[20 240 150 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Saturation bounds:');
uicontrol(f,...
  'Style','edit',...
  'Position',[175 240 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',satubs);
uicontrol(f,...
  'Style','edit',...
  'Position',[380 240 195 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'String',satlbs); 
uicontrol(f,...
  'Style','text',...
  'Position',[65 210 520 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','left',...
  'String','Uncertainty on process parameters                         		   Default variables');
uicontrol(f,...
  'Style','frame',...
  'Position',[50 55 200 150],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k');
uicontrol(gcf,...
  'Style','frame',...
  'Position',[280 55 290 150],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k');

temp_st0='';
temp_st1='';
if length(vub) ~= 0
 for k=1:length(vub)
  temp_st0=[temp_st0 num2str(vlb(k)) '  =<  x('];
  temp_st0=[temp_st0 num2str(k) ')  =<  ' num2str(vub(k))];
  temp_st1=strvcat(temp_st1,temp_st0);
  temp_st0='';
 end	
end

uicontrol(gcf,...
  'Style','text',...
  'String',temp_st1,...
  'Position',[65 60 180 140],...
  'HorizontalAlignment','Center',...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'Max',2); 
uicontrol(f,...
  'Style','push',...
  'Position',[260 20 80 25],...
  'String','OK',...
  'Callback','close');


% View default variables
%-------------------------------------------------------------

uicontrol(f,...
  'Style','text',...
  'Position',[285 180 250 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Noise amplification factor');
uicontrol(f,...
  'Style','text',...
  'Position',[465 180 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',num2str(Na));
uicontrol(f,...
  'Style','text',...
  'Position',[285 160 250 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Frequency Range (rad/unit time)');
temp='';
temp=[temp '1x10^'];
temp=[temp num2str(decade(1))];
temp=[temp ' to  1x10^'];
temp=[temp num2str(decade(2))];
uicontrol(f,...
  'Style','text',...
  'Position',[465 160 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',temp);
uicontrol(f,...
  'Style','text',...
  'Position',[285 140 250 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' # of frequency points per decade');
uicontrol(f,...
  'Style','text',...
  'Position',[465 140 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',num2str(numpdec));
uicontrol(f,...
  'Style','text',...
  'Position',[285 120 250 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Tolerance');
uicontrol(f,...
  'Style','text',...
  'Position',[465 120 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',num2str(Acc));
uicontrol(f,...
  'Style','text',...
  'Position',[285 100 250 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',' Infinity');
uicontrol(f,...
  'Style','text',...
  'Position',[465 100 100 18],...
  'Backgroundcolor','w',...
  'Foregroundcolor','k',...
  'HorizontalAlignment','Left',...
  'String',num2str(inf));

